/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-14 15:32:06 UTC)
 * on 2013-08-19 at 21:14:45 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.dfareporting.model;

/**
 * Represents the list of reports.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the DFA Reporting API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ReportList extends com.google.api.client.json.GenericJson {

  /**
   * The eTag of this response for caching purposes.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String etag;

  /**
   * The reports returned in this response.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Report> items;

  /**
   * The kind of list this is, in this case dfareporting#reportList.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Continuation token used to page through reports. To retrieve the next page of results, set the
   * next request's "pageToken" to the value of this field. The page token is only valid for a
   * limited amount of time and should not be persisted.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String nextPageToken;

  /**
   * The eTag of this response for caching purposes.
   * @return value or {@code null} for none
   */
  public java.lang.String getEtag() {
    return etag;
  }

  /**
   * The eTag of this response for caching purposes.
   * @param etag etag or {@code null} for none
   */
  public ReportList setEtag(java.lang.String etag) {
    this.etag = etag;
    return this;
  }

  /**
   * The reports returned in this response.
   * @return value or {@code null} for none
   */
  public java.util.List<Report> getItems() {
    return items;
  }

  /**
   * The reports returned in this response.
   * @param items items or {@code null} for none
   */
  public ReportList setItems(java.util.List<Report> items) {
    this.items = items;
    return this;
  }

  /**
   * The kind of list this is, in this case dfareporting#reportList.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * The kind of list this is, in this case dfareporting#reportList.
   * @param kind kind or {@code null} for none
   */
  public ReportList setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Continuation token used to page through reports. To retrieve the next page of results, set the
   * next request's "pageToken" to the value of this field. The page token is only valid for a
   * limited amount of time and should not be persisted.
   * @return value or {@code null} for none
   */
  public java.lang.String getNextPageToken() {
    return nextPageToken;
  }

  /**
   * Continuation token used to page through reports. To retrieve the next page of results, set the
   * next request's "pageToken" to the value of this field. The page token is only valid for a
   * limited amount of time and should not be persisted.
   * @param nextPageToken nextPageToken or {@code null} for none
   */
  public ReportList setNextPageToken(java.lang.String nextPageToken) {
    this.nextPageToken = nextPageToken;
    return this;
  }

  @Override
  public ReportList set(String fieldName, Object value) {
    return (ReportList) super.set(fieldName, value);
  }

  @Override
  public ReportList clone() {
    return (ReportList) super.clone();
  }

}
